import * as raw from './raw';
import { getUploadHttpClient } from '../../../upload-http-client';
const getBaseUrl = params => `/organizations/${params.organizationId}/app_uploads`;
const getAppUploadUrl = params => `${getBaseUrl(params)}/${params.appUploadId}`;
export const get = (http, params) => {
  const httpUpload = getUploadHttpClient(http);
  return raw.get(httpUpload, getAppUploadUrl(params));
};
export const del = (http, params) => {
  const httpUpload = getUploadHttpClient(http);
  return raw.del(httpUpload, getAppUploadUrl(params));
};
export const create = (http, params, payload) => {
  const httpUpload = getUploadHttpClient(http);
  const file = payload.file;
  return raw.post(httpUpload, getBaseUrl(params), file, {
    headers: {
      'Content-Type': 'application/octet-stream'
    }
  });
};